
#include "list.h"

/*@ type Length2 */

/*@ logic Length2 length2(list l1,list l2) reads l1->tl, l2->tl */

/*@ predicate length2_order(Length2 l1, Length2 l2) */

/*@ logic plist merge(plist l0,plist l1,list dummy) reads dummy->hd */  /* argghhhh */

/*@ predicate no_rep(plist l) */


/*@ requires (p0 != \null || q0 != \null) &&
             (\exists plist ps0,  plist qs0; 
	     llist(p0,ps0) && llist(q0,qs0) && disjoint(ps0,qs0))
  @ ensures \forall plist ps0, plist qs0; \old(llist(p0,ps0) && llist(q0,qs0)) => llist(\result,merge(ps0,qs0,\old(p0)))
  @*/
list merge (list p0, list q0) {
  list p = p0;
  list q = q0;
  list r = NULL;
  list s = NULL;
  /*@ ensures 1 */
  if ((q == NULL) || ((p != NULL) && (p->hd <= q->hd))) {  /* CORRECTED: VC's GENERATED WITH <, not <= */
    r = p;
    p = p->tl;
  } else {
    r = q;
    q = q->tl;
  }
  s = r;
  /*@ invariant 
        \exists plist rs, plist ps, plist qs;
           lpath(r,rs,s) && llist(p,ps) && llist(q,qs) && (s != \null) && \valid(s) &&
	    (\forall plist ps0, plist qs0; 
       	         (\old(llist(p0,ps0) && llist(q0,qs0)) => merge(ps0,qs0,\old(p0)) == app(rs,cons(s,merge(ps,qs,p))))) && 
	   (s->tl == p || s->tl == q) &&
           no_rep(cons(s,app (ps,app(qs,rs))))
    @ variant length2(p,q) for length2_order */
  while ((p != NULL) || (q != NULL)) {
    if ((q == NULL) || ((p != NULL) && (p->hd <= q->hd))) {
      s->tl = p;
      p = p->tl;
    } else {
      s->tl = q;
      q = q->tl;
    }	
    s = s->tl;
  }
  return r;
}

    
